diff -ruN ../nakedmudv2.7/src/io.c src/io.c
--- ../nakedmudv2.7/src/io.c	Sun Jul 31 17:13:52 2005
+++ src/io.c	Fri Oct  7 14:15:55 2005
@@ -82,250 +82,19 @@
 }
 
 
-char *read_file(const char *file) {
+BUFFER *read_file(const char *file) {
   FILE *fl;
-  static char contents[MAX_BUFFER];
-  int i;
 
   if((fl = fopen(file, "r")) == NULL)
     return NULL;
-
-  i = 0;
-  while((contents[i] = getc(fl)) != EOF)
-    i++;
-
-  contents[i] = '\0';
-  fclose(fl);
-  return strdup(contents);
-}
-
-
-/*
- * Reads one line from a file, and returns a
- * pointer to a _static array_ holding the line.
- */
-char *fread_line(FILE *fp)
-{
-  static char line[MAX_BUFFER];
-  int c, entry = 0;
-
-  /* read one line from the file */
-  c = getc(fp);
-  while (c != EOF && c != '\n')
-  {
-    line[entry] = c;
-    if (++entry > MAX_BUFFER - 1)
-    {
-      bug("Fread_line: Line to long.");
-      abort();
-    }
-    c = getc(fp);
-  }
-  line[entry] = '\0';
-
-  /* did we actually read anything ? */
-  if (entry == 0) return NULL;
-
-  /* return a pointer to the static buffer */
-  return line;
-}
-
-/*
- * Reads one number from a file, returning
- * the value as an integer, a leading '-' will
- * be intepreted as a negative value, and this
- * is the only non-digit that the function
- * will not choke and die upon reading.
- */
-int fread_number(FILE *fp)
-{
-  int c, number = 0;
-  bool negative = FALSE;
-
-  /* initial read */
-  c = getc(fp);
-
-  /* speed through leading spaces */
-  while (c != EOF && (c == ' ' || c == '\n'))
-    c = getc(fp);
-
-  /* so what did we get ? */
-  if (c == EOF)
-  {
-    bug("Fread_number: EOF encountered.");
-    abort();
-  }
-  else if (c == '-')
-    negative = TRUE;
-  else if (!isdigit(c))
-  {
-    bug("Fread_number: Not a number.");
-    abort();
-  }
-  else
-    number = c - '0';
-
-  /* keep counting up */
-  while (isdigit(c = getc(fp)))
-    number = number * 10 + c - '0';
-
-  /* push back the non-digit */
-  ungetc(c, fp);
-
-  /* we have a number */
-  return (negative ? (0 - number) : number);
-}
-
-/*
- * Reads one long number from a file, returning
- * the value as a long, a leading '-' will
- * be intepreted as a negative value, and this
- * is the only non-digit that the function
- * will not choke and die upon reading.
- */
-long fread_long(FILE *fp)
-{
-  long c, number = 0;
-  bool negative = FALSE;
-
-  /* initial read */
-  c = getc(fp);
-
-  /* speed through leading spaces */
-  while (c != EOF && (c == ' ' || c == '\n'))
-    c = getc(fp);
-
-  /* so what did we get ? */
-  if (c == EOF)
-  {
-    bug("Fread_long: EOF encountered.");
-    abort();
-  }
-  else if (c == '-')
-    negative = TRUE;
-  else if (!isdigit(c))
-  {
-    bug("Fread_long: Not a number.");
-    abort();
-  }
-  else
-    number = c - '0';
-
-  /* keep counting up */
-  while (isdigit(c = getc(fp)))
-    number = number * 10 + c - '0';
-
-  /* push back the non-digit */
-  ungetc(c, fp);
-
-  /* we have a number */
-  return (negative ? (0 - number) : number);
-}
-
-/*
- * Reads one full block of text, which ends with a
- * '~' (tilde). The result will be copied into an
- * allocated buffer and a pointer to that buffer
- * will be returned. Remember to free the memory when
- * you are done using it.
- */
-char *fread_string(FILE *fp)
-{
-  char buf[4 * MAX_BUFFER];
-  int c, count = 0;
-
-  /* initial read */
-  c = getc(fp);
-
-  /* speed through leading newlines. 
-     Don't skip through spaces - some descriptions are indented */
-  while (/*c == ' ' || */c == '\n')
-    c = getc(fp);
-
-  /* better not have reached the end of the file */
-  if (c == EOF) {
-    bug("Fread_string: EOF encountered.");
-    abort();
-  }
-
-  /* and keep reading */
-  while (c != EOF && c != '~')
-  {
-    if (c == '\n') {
-      buf[count++] = '\r'; 
-      buf[count] = '\n';
-    }
-    else if (c == '\r') {
-      c = getc(fp);
-      continue;
-    }
-    else 
-      buf[count] = c;
-
-    count++;
-
-    if (count > (4 * MAX_BUFFER - 2))
-    {
-      bug("Fread_string: String to long.");
-      abort();
-    }
-    c = getc(fp);
-  }
-  buf[count] = '\0';
-
-  if (c == EOF)
-    bug("Fread_string: Non-fatal error, encountered EOF instead of ~");
   else {
-    // if the ~ is followed by a newline, eat it up
-    c = getc(fp);
-    if(c != '\n')
-      ungetc(c, fp);
-  }
-
-  return strdup(buf);
-}
-
-/*
- * Reads one single word, ending with the first
- * encountered space ' '. Any leading spaces will
- * be ignored, and the result will be copied into
- * a static buffer, and a pointer to that buffer
- * will be returned.
- */
-char *fread_word(FILE *fp)
-{
-  static char buf[MAX_BUFFER];
-  int c, count = 0;
+    BUFFER *buf = newBuffer(MAX_BUFFER);
+    char     ch = '\0';
 
-  /* initial read */
-  c = getc(fp); 
+    while((ch = getc(fl)) != EOF)
+      bprintf(buf, "%c", ch);
 
-  /* speed through leading spaces and linebreaks */
-  while (c != EOF && (c == ' ' || c == '\n'))
-    c = getc(fp);
-
-  /* better not have reached the end of the file */
-  if (c == EOF)
-  {
-    bug("Fread_word: EOF encountered.");
-    abort();
-  }
-
-  /* and keep reading */
-  while (c != EOF && c != ' ' && c != '\n')
-  {
-    buf[count] = c;
-    if (++count > MAX_BUFFER - 1)
-    {
-      bug("Fread_word: Word to long.");
-      abort();
-    }
-    c = getc(fp);
+    fclose(fl);
+    return buf;
   }
-  buf[count] = '\0';
-
-  /* push back the last read if it was EOF */
-  if (c == EOF) ungetc(c, fp);
-
-  return buf;
 }
diff -ruN ../nakedmudv2.7/src/items/container.c src/items/container.c
--- ../nakedmudv2.7/src/items/container.c	Sun Jul 31 17:13:51 2005
+++ src/items/container.c	Fri Oct  7 14:15:55 2005
@@ -7,16 +7,25 @@
 // interacting with container types.
 //
 //*****************************************************************************
-
 #include "../mud.h"
 #include "../storage.h"
 #include "../object.h"
 #include "../world.h"
 #include "../socket.h"
+#include "../utils.h"
 #include "../olc2/olc.h"
 
 #include "items.h"
 #include "iedit.h"
+#include "container.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pyobj.h"
 
 
 
@@ -25,7 +34,7 @@
 //*****************************************************************************
 typedef struct container_data {
   double capacity;
-  int    key;
+  char  *key;
   int    pick_diff;
   bool   closable;
   bool   closed;
@@ -35,7 +44,7 @@
 CONTAINER_DATA *newContainerData() {
   CONTAINER_DATA *data = malloc(sizeof(CONTAINER_DATA));
   data->capacity  = 0;
-  data->key       = NOTHING;
+  data->key       = strdup("");
   data->pick_diff = 0;
   data->closed    = FALSE;
   data->locked    = FALSE;
@@ -43,11 +52,13 @@
 }
 
 void deleteContainerData(CONTAINER_DATA *data) {
+  if(data->key) free(data->key);
   free(data);
 }
 
 void containerDataCopyTo(CONTAINER_DATA *from, CONTAINER_DATA *to) {
   *to = *from;
+  to->key = strdupsafe(from->key);
 }
 
 CONTAINER_DATA *containerDataCopy(CONTAINER_DATA *data) {
@@ -59,7 +70,7 @@
 STORAGE_SET *containerDataStore(CONTAINER_DATA *data) {
   STORAGE_SET *set = new_storage_set();
   store_double(set, "capacity", data->capacity);
-  store_int   (set, "key",      data->key);
+  store_string(set, "key",      data->key);
   store_int   (set, "pick_diff",data->pick_diff);
   store_int   (set, "closable", data->closable);
   store_int   (set, "closed",   data->closed);
@@ -69,8 +80,8 @@
 
 CONTAINER_DATA *containerDataRead(STORAGE_SET *set) {
   CONTAINER_DATA *data = newContainerData();
+  data->key      = strdupsafe(read_string(set, "key"));
   data->capacity = read_double(set, "capacity");
-  data->key      = read_int   (set, "key");
   data->pick_diff= read_int   (set, "pick_diff");
   data->closable = read_int   (set, "closable");
   data->closed   = read_int   (set, "closed");
@@ -108,7 +119,7 @@
   return data->locked;
 }
 
-int  containerGetKey     (OBJ_DATA *obj) {
+const char *containerGetKey(OBJ_DATA *obj) {
   CONTAINER_DATA *data = objGetTypeData(obj, "container");
   return data->key;
 }
@@ -133,9 +144,10 @@
   data->locked = locked;
 }
 
-void containerSetKey     (OBJ_DATA *obj, int  vnum) {
+void containerSetKey(OBJ_DATA *obj, const char *key) {
   CONTAINER_DATA *data = objGetTypeData(obj, "container");
-  data->key = vnum;
+  if(data->key) free(data->key);
+  data->key = strdup(key);
 }
 
 void containerSetPickDiff(OBJ_DATA *obj, int  diff) {
@@ -156,13 +168,11 @@
 void iedit_container_menu   (SOCKET_DATA *sock, CONTAINER_DATA *data) {
   send_to_socket(sock, 
 		 "{g1) Capacity : {c%1.2lf\r\n"
-		 "{g2) Key      : {c%d (%s)\r\n"
+		 "{g2) Key      : {c%s\r\n"
 		 "{g3) Closable : {c%s\r\n"
 		 "{g4) Pick diff: {c%d\r\n",
 		 data->capacity,
-		 data->key, 
-		 (worldGetObj(gameworld, data->key) ? 
-		  objGetName(worldGetObj(gameworld, data->key)) : "nothing"),
+		 data->key,
 		 (data->closable ? "yes" : "no"),
 		 data->pick_diff);
 }
@@ -174,7 +184,7 @@
     text_to_buffer(sock, "Enter a new weight capacity for the container: ");
     return IEDIT_CONTAINER_CAPACITY;
   case '2':
-    text_to_buffer(sock, "Enter akey vnum for the container (-1 for none): ");
+    text_to_buffer(sock, "Enter akey vnum for the container: ");
     return IEDIT_CONTAINER_KEY;
   case '3':
     data->closable = (data->closable + 1) % 2;
@@ -197,15 +207,8 @@
     return TRUE;
   }
   case IEDIT_CONTAINER_KEY: {
-    int key = atoi(arg);
-    // ugh... ugly logic. Clean this up one day?
-    //   Make sure what we're getting is a positive number or make sure it is
-    //   the NOTHING number (-1). Also make sure that, if it's not NOTHING, it
-    //   corresponds to a vnum of an object already created.
-    if((key != NOTHING && !worldGetObj(gameworld, key)) ||
-       (key != NOTHING && !isdigit(*arg)))
-      return FALSE;
-    data->key = key;
+    if(data->key) free(data->key);
+    data->key = strdupsafe(arg);
     return TRUE;
   }
   case IEDIT_CONTAINER_PICK_DIFF: {
@@ -222,6 +225,276 @@
 
 
 //*****************************************************************************
+// pyobj getters and setters
+//*****************************************************************************
+PyObject *PyObj_getcontainercapacity(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "container"))
+    return Py_BuildValue("d", containerGetCapacity(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get capacity for container.");
+    return NULL;
+  }
+}
+
+int PyObj_setcontainercapacity(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set capacity for nonexistent "
+		 "container, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "container")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set capacity for non-container, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyFloat_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "container capacity must be a double.");
+    return -1;
+  }
+
+  containerSetCapacity(obj, PyFloat_AsDouble(value));
+  return 0;
+}
+
+PyObject *PyObj_getcontainerkey(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "container"))
+    return Py_BuildValue("s", containerGetKey(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get keys for containers.");
+    return NULL;
+  }
+}
+
+int PyObj_setcontainerkey(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA   *obj = PyObj_AsObj(self);
+  const char *key = NULL;
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set key for nonexistent "
+		 "container, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "container")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set key for non-container, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(PyString_Check(value))
+    key =get_fullkey(PyString_AsString(value),get_key_locale(objGetClass(obj)));
+  else if(PyObj_Check(value)) {
+    OBJ_DATA *key_obj = PyObj_AsObj(value);
+    if(key_obj != NULL)
+      key = objGetClass(key_obj);
+    else {
+      PyErr_Format(PyExc_TypeError, "Tried to set key for %s as nonexistaent "
+		   "obj, %d", objGetClass(obj), PyObj_AsUid(value));
+      return -1;
+    }
+  }
+
+  // make sure we have a key
+  if(key == NULL) {
+    PyErr_Format(PyExc_TypeError, "Container keys must be strings or objects.");
+    return -1;
+  }
+
+  containerSetKey(obj, key);
+  return 0;
+}
+
+PyObject *PyObj_getcontainerclosable(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) return NULL;
+  else if(objIsType(obj, "container"))
+    return Py_BuildValue("i", containerIsClosable(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only check if containers are closable.");
+    return NULL;
+  }
+}
+
+PyObject *PyObj_getcontainerclosed  (PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) return NULL;
+  else if(objIsType(obj, "container"))
+    return Py_BuildValue("i", containerIsClosed(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only check if containers are closed.");
+    return NULL;
+  }
+}
+
+PyObject *PyObj_getcontainerlocked  (PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) return NULL;
+  else if(objIsType(obj, "container"))
+    return Py_BuildValue("i", containerIsLocked(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only check if containers are locked.");
+    return NULL;
+  }
+}
+
+PyObject *PyObj_getcontainerpickdiff(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) return NULL;
+  else if(objIsType(obj, "container"))
+    return Py_BuildValue("i", containerGetPicKDiff(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only check pick diffs on containers.");
+    return NULL;
+  }
+}
+
+int PyObj_setcontainerpickdiff(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to change pickdiff on nonexistent "
+		 "container, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "container")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set pick for non-container, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyInt_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "container pickdiff must be an integer.");
+    return -1;
+  }
+
+  containerSetPickDiff(obj, PyInt_AsLong(value));
+  return 0;
+}
+
+int PyObj_setcontainerclosable(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to change closable on nonexistent "
+		 "container, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "container")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set closable for non-container, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyInt_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "container closability must be a boolean.");
+    return -1;
+  }
+
+  containerSetClosable(obj, PyInt_AsLong(value));
+  if(PyInt_AsLong(value) == 0) {
+    containerSetLocked(obj, FALSE);
+    containerSetClosed(obj, FALSE);
+  }
+  return 0;
+}
+
+int PyObj_setcontainerclosed  (PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to change closed on nonexistent "
+		 "container, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "container")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set closed for non-container, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyInt_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "container close status must be a boolean.");
+    return -1;
+  }
+
+  containerSetClosed(obj, PyInt_AsLong(value));
+  if(PyInt_AsLong(value) == 0)
+    containerSetLocked(obj, FALSE);
+  else
+    containerSetClosable(obj, TRUE);
+  return 0;
+}
+
+int PyObj_setcontainerlocked  (PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to change locked on nonexistent "
+		 "container, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "container")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set locked for non-container, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyInt_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "container lock status must be a boolean.");
+    return -1;
+  }
+
+  containerSetLocked(obj, PyInt_AsLong(value));
+  if(PyInt_AsLong(value) != 0) {
+    containerSetClosable(obj, TRUE);
+    containerSetClosed(obj, TRUE);
+  }
+  return 0;
+}
+
+void container_from_proto(CONTAINER_DATA *data, BUFFER *buf) {
+  char line[MAX_BUFFER];
+  const char *code = bufferString(buf);
+  do {
+    code = strcpyto(line, code, '\n');
+    char *lptr = line;
+    if(!strncasecmp(lptr, "me.container_capacity", 21)) {
+      while(*lptr && !isdigit(*lptr)) lptr++;
+      data->capacity = atoi(lptr);
+    }
+    else if(!strncasecmp(lptr, "me.container_key", 16)) {
+      while(*lptr && *lptr != '\"') lptr++;
+      lptr++; // skip leading "
+      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill ending "
+      if(data->key) free(data->key);
+      data->key = strdupsafe(lptr);
+    }
+    else if(!strncasecmp(lptr, "me.container_pick_diff", 22)) {
+      while(*lptr && !isdigit(*lptr)) lptr++;
+      data->pick_diff = atoi(lptr);
+    }
+    else if(!strcasecmp(lptr, "me.container_is_closable = True"))
+      data->closable = TRUE;
+    else; // ignore line
+  } while(*code != '\0');
+}
+
+void container_to_proto(CONTAINER_DATA *data, BUFFER *buf) {
+  if(data->capacity > 0)
+    bprintf(buf, "me.container_capacity    = %1.3lf\n", data->capacity);
+  if(*data->key)
+    bprintf(buf, "me.container_key         = \"%s\"\n", data->key);
+  if(data->pick_diff > 0)
+    bprintf(buf, "me.container_pick_diff   = %d\n", data->pick_diff);
+  if(data->closable == TRUE)
+    bprintf(buf, "me.container_is_closable = True\n");
+}
+
+
+
+//*****************************************************************************
 // install the container item type
 //*****************************************************************************
 
@@ -235,5 +508,23 @@
 
   // set up the container OLC too
   item_add_olc("container", iedit_container_menu, iedit_container_chooser, 
-  	       iedit_container_parser);
+  	       iedit_container_parser, container_from_proto,container_to_proto);
+  PyObj_addGetSetter("container_capacity",
+		     PyObj_getcontainercapacity, PyObj_setcontainercapacity,
+		     "Sets the maximum amount of weight the container holds.");
+  PyObj_addGetSetter("container_key", 
+		     PyObj_getcontainerkey, PyObj_setcontainerkey,
+		     "The key that opens the container.");
+  PyObj_addGetSetter("container_pick_diff",
+		     PyObj_getcontainerpickdiff, PyObj_setcontainerpickdiff,
+		     "The picking difficulty of the container,");
+  PyObj_addGetSetter("container_is_closable", 
+		     PyObj_getcontainerclosable, PyObj_setcontainerclosable,
+		     "true or false if the container can be closed.");
+  PyObj_addGetSetter("container_is_closed", 
+		     PyObj_getcontainerclosed, PyObj_setcontainerclosed,
+		      "true or false if the container is closed.");
+  PyObj_addGetSetter("container_is_locked", 
+		     PyObj_getcontainerlocked, PyObj_setcontainerlocked,
+		      "true or false if the container is locked.");
 }
diff -ruN ../nakedmudv2.7/src/items/container.h src/items/container.h
--- ../nakedmudv2.7/src/items/container.h	Sun Jul 31 17:13:51 2005
+++ src/items/container.h	Fri Oct  7 14:15:55 2005
@@ -11,16 +11,16 @@
 //*****************************************************************************
 
 double containerGetCapacity(OBJ_DATA *obj);
-bool   containerIsClosable (OBJ_DATA *obj);
-bool   containerIsClosed   (OBJ_DATA *obj);
-bool   containerIsLocked   (OBJ_DATA *obj);
-int    containerGetKey     (OBJ_DATA *obj);
+bool    containerIsClosable(OBJ_DATA *obj);
+bool      containerIsClosed(OBJ_DATA *obj);
+bool      containerIsLocked(OBJ_DATA *obj);
+const char *containerGetKey(OBJ_DATA *obj);
 int    containerGetPicKDiff(OBJ_DATA *obj);
 void   containerSetCapacity(OBJ_DATA *obj, double capacity);
-void   containerSetClosed  (OBJ_DATA *obj, bool closed);
+void     containerSetClosed(OBJ_DATA *obj, bool closed);
 void   containerSetClosable(OBJ_DATA *obj, bool closable);
-void   containerSetLocked  (OBJ_DATA *obj, bool locked);
-void   containerSetKey     (OBJ_DATA *obj, int  vnum);
+void     containerSetLocked(OBJ_DATA *obj, bool locked);
+void        containerSetKey(OBJ_DATA *obj, const char *key);
 void   containerSetPickDiff(OBJ_DATA *obj, int  diff);
 
 #endif // CONTAINER_H
diff -ruN ../nakedmudv2.7/src/items/furniture.c src/items/furniture.c
--- ../nakedmudv2.7/src/items/furniture.c	Sun Jul 31 17:13:51 2005
+++ src/items/furniture.c	Fri Oct  7 14:15:55 2005
@@ -8,6 +8,7 @@
 //*****************************************************************************
 
 #include "../mud.h"
+#include "../utils.h"
 #include "../storage.h"
 #include "../object.h"
 #include "../world.h"
@@ -21,6 +22,14 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pyobj.h"
+
+
+
+//*****************************************************************************
 // item data for furnitures
 //*****************************************************************************
 typedef struct furniture_data {
@@ -89,8 +98,8 @@
 }  
 
 const char *furniture_names[NUM_FURNITURES] = {
-  "table furniture",
-  "sitting furniture"
+  "at",
+  "on"
 };
 
 const char *furnitureTypeGetName(int type) {
@@ -116,8 +125,8 @@
 // the resedit olc needs these declared
 void iedit_furniture_menu(SOCKET_DATA *sock, FURNITURE_DATA *data) {
   send_to_socket(sock, 
-		 "{g1) Capacity : {c%d\r\n"
-		 "{g2) Type     : {y[{c%s{y]\r\n",
+		 "{g1) Capacity: {c%d\r\n"
+		 "{g2) Sit Type: {c%s\r\n",
 		 data->capacity,
 		 furnitureTypeGetName(data->type));
 }
@@ -157,6 +166,108 @@
   }
 }
 
+void furniture_from_proto(FURNITURE_DATA *data, BUFFER *buf) {
+  const char *code = bufferString(buf);
+  char line[SMALL_BUFFER];
+  char *lptr = line;
+  int capacity = 0;
+
+  // two lines: capacity and type. First capacity, then type
+  code = strcpyto(line, code, '\n');
+  sscanf(line, "me.furniture_capacity = %d", &capacity);
+  data->capacity = capacity;
+
+  code = strcpyto(line, code , '\n');
+  while(*lptr && *lptr != '\"') lptr++;
+  lptr++; // skip the leading "
+  lptr[next_letter_in(lptr, '\"')] = '\0'; // kill closing "
+  data->type = furnitureTypeGetNum(lptr);
+}
+
+void furniture_to_proto(FURNITURE_DATA *data, BUFFER *buf) {
+  bprintf(buf, "me.furniture_capacity = %d\n",   data->capacity);
+  bprintf(buf, "me.furniture_type     = \"%s\"\n", 
+	  furnitureTypeGetName(data->type));
+}
+
+
+
+//*****************************************************************************
+// pyobj getters and setters
+//*****************************************************************************
+PyObject *PyObj_getfurncapacity(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "furniture"))
+    return Py_BuildValue("i", furnitureGetCapacity(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get capacity for furniture.");
+    return NULL;
+  }
+}
+
+int PyObj_setfurncapacity(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set capacity for nonexistent "
+		 "furniture, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "furniture")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set capacity for non-furniture, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyInt_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "furniture capacity must be an integer.");
+    return -1;
+  }
+
+  furnitureSetCapacity(obj, PyInt_AsLong(value));
+  return 0;
+}
+
+PyObject *PyObj_getfurntype(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "furniture"))
+    return Py_BuildValue("s", furnitureTypeGetName(furnitureGetType(obj)));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get furniture type for furniture.");
+    return NULL;
+  }
+}
+
+int PyObj_setfurntype(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set furniture type for "
+		 "nonexistent furniture, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "furniture")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set furniture type for "
+		 "non-furniture, %s", objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyString_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "furniture type must be a string.");
+    return -1;
+  }
+  else if(furnitureTypeGetNum(PyString_AsString(value)) == FURNITURE_NONE) {
+    PyErr_Format(PyExc_TypeError, "Invalid furniture type, %s", 
+		 PyString_AsString(value));
+    return -1;
+  }
+
+  furnitureSetType(obj, furnitureTypeGetNum(PyString_AsString(value)));
+  return 0;
+}
+
 
 
 //*****************************************************************************
@@ -173,5 +284,12 @@
 
   // set up the furniture OLC too
   item_add_olc("furniture", iedit_furniture_menu, iedit_furniture_chooser, 
-  	       iedit_furniture_parser);
+  	       iedit_furniture_parser, furniture_from_proto,furniture_to_proto);
+
+  // add our getters and setters for furniture
+  PyObj_addGetSetter("furniture_capacity", 
+		     PyObj_getfurncapacity, PyObj_setfurncapacity,
+		     "The capacity of a furniture object.");
+  PyObj_addGetSetter("furniture_type", PyObj_getfurntype, PyObj_setfurntype,
+		     "The type of furniture this is: 'at' or 'on'.");
 }
diff -ruN ../nakedmudv2.7/src/items/iedit.c src/items/iedit.c
--- ../nakedmudv2.7/src/items/iedit.c	Sun Jul 31 17:13:51 2005
+++ src/items/iedit.c	Fri Oct  7 14:15:55 2005
@@ -32,16 +32,21 @@
 HASHTABLE *item_olc_table = NULL;
 
 typedef struct item_olc_data {
-  void    (* menu)(SOCKET_DATA *sock, void *data);
-  int  (* chooser)(SOCKET_DATA *sock, void *data, const char *option);
-  bool  (* parser)(SOCKET_DATA *sock, void *data, int choice, const char *arg);
+  void       (* menu)(SOCKET_DATA *sock, void *data);
+  int     (* chooser)(SOCKET_DATA *sock, void *data, const char *option);
+  bool     (* parser)(SOCKET_DATA *sock, void *data,int choice,const char *arg);
+  void (* from_proto)(void *data, BUFFER *buf);
+  void   (* to_proto)(void *data, BUFFER *buf);
 } ITEM_OLC_DATA;
 
-ITEM_OLC_DATA *newItemOLC(void *menu, void *chooser, void *parser) {
+ITEM_OLC_DATA *newItemOLC(void *menu, void *chooser, void *parser, 
+			  void *from_proto, void *to_proto) {
   ITEM_OLC_DATA *data = malloc(sizeof(ITEM_OLC_DATA));
-  data->menu    = menu;
-  data->chooser = chooser;
-  data->parser  = parser;
+  data->menu       = menu;
+  data->chooser    = chooser;
+  data->parser     = parser;
+  data->from_proto = from_proto;
+  data->to_proto   = to_proto;
   return data;
 }
 
@@ -68,7 +73,7 @@
   char *type = NULL;
   int col = 0;
 
-  text_to_buffer(sock, "{wEditable item types:\r\n");
+  text_to_buffer(sock, "{wEditable item types:{g\r\n");
   ITERATE_LIST(type, list_i) {
     send_to_socket(sock, "  %s%-14s%s", (objIsType(obj, type) ? "{y" : "{g"),
 		   type, ((col != 0 && col % 4 == 0) ? "\r\n": "   "));
@@ -80,12 +85,13 @@
   if(col % 4 != 0) text_to_buffer(sock, "\r\n");
 }
 
-void item_add_olc(const char *type, void *menu, void *chooser, void *parser) {
+void item_add_olc(const char *type, void *menu, void *chooser, void *parser,
+		  void *from_proto, void *to_proto) {
   ITEM_OLC_DATA *data = NULL;
   // check to see if we already have functions for this item type installed
   if( (data = hashRemove(item_olc_table, type)) != NULL)
     deleteItemOLC(data);
-  data = newItemOLC(menu, chooser, parser);
+  data = newItemOLC(menu, chooser, parser, from_proto, to_proto);
   hashPut(item_olc_table, type, data);
 }
 
@@ -128,6 +134,22 @@
     return TRUE;
   default: return FALSE;
   }
+}
+
+void (* item_from_proto_func(const char *type))(void *data, BUFFER *buf) {
+  ITEM_OLC_DATA *funcs = hashGet(item_olc_table, type);
+  if(funcs == NULL)
+    return NULL;
+  else
+    return funcs->from_proto;
+}
+
+void (* item_to_proto_func(const char *type))(void *data, BUFFER *buf) {
+  ITEM_OLC_DATA *funcs = hashGet(item_olc_table, type);
+  if(funcs == NULL)
+    return NULL;
+  else
+    return funcs->to_proto;
 }
 
 
diff -ruN ../nakedmudv2.7/src/items/iedit.h src/items/iedit.h
--- ../nakedmudv2.7/src/items/iedit.h	Sun Jul 31 17:13:51 2005
+++ src/items/iedit.h	Fri Oct  7 14:15:55 2005
@@ -17,12 +17,33 @@
 //
 //*****************************************************************************
 
-void item_add_olc(const char *type, void *menu, void *chooser, void *parser);
+// called by items.c
+void init_item_olc(void);
+
+//
+// menu, chooser, and parser are standard OLC functions of the same name that
+// are typically supplied (see ../olc2/olc.h). from_proto and to_proto are
+// functions that aid in the conversion between item types and python scripts
+// (without actually running the script). If we want to have a non-scripting
+// interface for builders, we have to be able to do this. It's pretty simple.
+// For examples on how to go about doing this, see portal.c, container.c, and
+// worn.c. from_proto should take in the data for an item type and a buffer of
+// code relevant to that item type. It should then set values for the item type
+// data, based on the code. It should be of the form:
+//   void from_proto(type *item_type_data, BUFFER *script)
+// to_proto should do the reverse: given type data, append it to a buffer that
+// is an object prototype (python script). It should also be of the form:
+//   void to_proto(type *item_type_data, BUFFER *script)
+void item_add_olc(const char *type, void *menu, void *chooser, void *parser,
+		  void *from_proto, void *to_proto);
 
 //
 // these functions will be needed by oedit
 void iedit_menu(SOCKET_DATA *sock, OBJ_DATA *obj);
 int  iedit_chooser(SOCKET_DATA *sock, OBJ_DATA *obj, const char *option);
 bool iedit_parser(SOCKET_DATA *sock, OBJ_DATA *obj,int choice, const char *arg);
+
+void (* item_from_proto_func(const char *type))(void *data, BUFFER *buf);
+void   (* item_to_proto_func(const char *type))(void *data, BUFFER *buf);
 
 #endif // IEDIT_H
diff -ruN ../nakedmudv2.7/src/items/items.c src/items/items.c
--- ../nakedmudv2.7/src/items/items.c	Sun Jul 31 17:13:51 2005
+++ src/items/items.c	Fri Oct  7 14:15:55 2005
@@ -20,6 +20,7 @@
 #include "../storage.h"
 
 #include "items.h"
+#include "iedit.h"
 
 
 
@@ -198,7 +199,7 @@
 				       itemDataRead));
 
   // initialize item olc
-  extern void init_item_olc(void); init_item_olc();
+  init_item_olc();
 
   // now, initialize our basic items types
   extern void init_container(); init_container();
